program rosagut ; { for satellites of the giant planets }
{$APPTYPE CONSOLE}
uses
  SysUtils , { for all action }
  UnTypVar , { types and procedures Get and Free memory }
  unrowini , { for procedures RecNullo RowNullo }
  unincini , { for procedure IncSimple P_1(cos(H))=cos(H) }
  unecanom , { for procedure powerange }
  unlegfun , { for procedure ForLegFun P_n(cos(H)) by recurence }
  unfunone , { for procedure pertufone to sum[r^n/r'^(n+1)*P_n] }
  unfunons , { for procedure secufone secular terms }
  unfranom , { for procedure powerunge giant planet 1/r' in power }
  unfutons , { for procedure secutone the second transformation }
  unpartif , { for procedure allparmdif partial derivations with L G H }
  unparuso , { for procedure DifWithDelon dF/d(L,G,H) }
  unpoibra , { for procedure PoiSecondBra }
  ungutons ; { for procedure secustre the third secular terms }
var
  f  : textfile ; { text file rosagut.ina with initial values }
  n  : byte ;     { maximum power for giant planet elements but n<=4 }
  m  : byte ;     { maximum order for the Legandre polinoms but m<=4 }
begin
  // Insert user code here

  assignfile(f,'rosagut.ina'); { initial values for theory }
  reset(f); { to open to read text file with number values }
  readln(f,n); { maximum power for giant planet elements but n<=4 }
  if  n > 4  then  n:=4; { to limit maximum power }
  numsum:=n;   { to global variable from UnTypVar }
  readln(f,m); { maximum order for the Legandre polinoms but m<=4 }
  if  m > 4  then  m:=4; { to limit maximum order }
  if  m < 2  then  m:=2; { only for P_2(cos(H) }
  numpol:=m;   { to global variable from UnTypVar }
  closefile(f); { there are all number to build our theory }

  GetRowMem ;     { from UnTypVar }
  RecNullo ;      { from unrowini nullo to rowvar }
  RowNullo ;      { from unrowini nullo to arrays }
  powerange ;     { unecanom for r=a-a*e*cos(E) in power }
  IncSimple ;     { from unincini cos(H) to rowcoh^ }
  ForLegFun ;     { unlegfun with maximim order for Legandre polinoms }
  pertufone ;     { from unfunone }
  secufone ;      { from unfunons }
  powerunge ;     { from unfranom }
  secutone ;      { from unfutons }
  allparmdif ;    { from unpartif derivations with L G H }
                  { from unparuso to differentiate with L G H }
  DifWithDelon(1,'prefol'); { derivations function F_1  long }
  DifWithDelon(1,'pregol'); { derivations function ~F_1 very long }
  DifWithDelon(1,'pregos'); { derivations function ~S_1 long }
                  { from unparuso to differentiate with l g h }
  DifWithDelan(1,'prefol'); { derivations function F_1  long }
  DifWithDelan(1,'pregol'); { derivations function ~F_1 very long }
  DifWithDelan(1,'pregos'); { derivations function ~S_1 long }
  PoiSecondBra ;  { unpoibra 1/2*[F_1,~S_1]+1/2*[~F_1,~S_1] }
  secustre ;      { from ungutons }
  FreeRowMem ;    { from UnTypVar }
end.
