{ to obtain Poisson bracket
  [F,S] = + dF/dL * dS/dl - dF/dl * dS/dL
          + dF/dG * dS/dg - dF/dg * dS/dG
          + dF/dH * dS/dh - dF/dh * dS/dH
  row for derivative of function F
      in text files sa 11(L) 12(G) 13(H) .txt
      in text files sa 21(l) 22(g) 23(h) .txt
  row for derivative of function S
      in text files sb 11(L) 12(G) 13(H) .txt
      in text files sb 21(l) 22(g) 23(h) .txt }
unit unpoibra ; { poisson bracket }
interface
uses
  untypvar ; { types global variables }
{ result to array ra^ may be ma terms }
procedure PoissonBrackett ( am  : extended ; { simple factor }
                            sa  : shortstring ; { part of the name F }
                            sb  : shortstring ; { part of the name S }
                            var  ma  : word ;   { result number of terms }
                            var  ra  : TRowPtr ) ; { to this array }
{ to obtain 1/2*[F_1,~S_1]+1/2*[~F_1,~S_1]
  row for  F_1 d F_1/d(L,G,H,l,g,h) in prefol 1 11 12 13 21 22 23 .txt
  row for ~F_1 d~F_1/d(L,G,H,l,g,h) in pregol 1 11 12 13 21 22 23 .txt
  row for ~S_1 d~S_1/d(L,G,H,l,g,h) in pregos 1 11 12 13 21 22 23 .txt }
procedure PoiSecondBra ;
implementation
uses
  unwrtext , { procedure texttorow rowtotext }
  unrowmul , { procedure MultForRow rowone^*rowtwo^=rowtre^ }
  unrowcor ; { procedure rowcote to correct with power of p }
{ result to array ra^ may be ma terms }
procedure PoissonBrackett ( am  : extended ; { simple factor }
                            sa  : shortstring ; { part of the name F }
                            sb  : shortstring ; { part of the name S }
                            var  ma  : word ;   { result number of terms }
                            var  ra  : TRowPtr ) ; { to this array }
var
  m  : word ; { count for terms }
begin
  mectre:=0; { initial nullo terms  global rowtre^[..] }
  { dF/dL to array rowone^ the  first function in brac }
  texttorow(11,sa,mecone,rowone); { mecone terms dF/dL }
  { dS/dl to array rowtwo^ the second function in brac }
  texttorow(21,sb,mectwo,rowtwo); { mectwo terms dS/dl }
  MultForRow(+am); { unrowmul with factor +am  rowtre^ }
  { dF/dl to array rowone^ the  first function in brac }
  texttorow(21,sa,mecone,rowone); { mecone terms dF/dl }
  { dS/dL to array rowtwo^ the second function in brac }
  texttorow(11,sb,mectwo,rowtwo); { mectwo terms dS/dL }
  MultForRow(-am); { unrowmul with factor -am  rowtre^ }
  for m:=1 to mectre do    { all terms from rowtre^ }
    begin                  { to array ra^ ma terms }
      ma:=ma+1;            { the next number }
      ra^[ma]:=rowtre^[m]; { for the next term }
    end;
  writeln('+dF/dL*dS/dl-dF/dl*dS/dL',mectre:10,ma:10);
  mectre:=0; { initial nullo terms  global rowtre^[..] }
  { dF/dG to array rowone^ the  first function in brac }
  texttorow(12,sa,mecone,rowone); { mecone terms dF/dG }
  { dS/dg to array rowtwo^ the second function in brac }
  texttorow(22,sb,mectwo,rowtwo); { mectwo terms dS/dg }
  MultForRow(+am); { unrowmul with factor +am  rowtre^ }
  { dF/dg to array rowone^ the  first function in brac }
  texttorow(22,sa,mecone,rowone); { mecone terms dF/dg }
  { dS/dG to array rowtwo^ the second function in brac }
  texttorow(12,sb,mectwo,rowtwo); { mectwo terms dS/dG }
  MultForRow(-am); { unrowmul with factor -am  rowtre^ }
  for m:=1 to mectre do    { all terms from rowtre^ }
    begin                  { to array ra^ ma terms }
      ma:=ma+1;            { the next number }
      ra^[ma]:=rowtre^[m]; { for the next term }
    end;
  writeln('+dF/dG*dS/dg-dF/dg*dS/dG',mectre:10,ma:10);
  mectre:=0; { initial nullo terms  global rowtre^[..] }
  { dF/dH to array rowone^ the  first function in brac }
  texttorow(13,sa,mecone,rowone); { mecone terms dF/dH }
  { dS/dh to array rowtwo^ the second function in brac }
  texttorow(23,sb,mectwo,rowtwo); { mectwo terms dS/dh }
  MultForRow(+am); { unrowmul with factor +am  rowtre^ }
  { dF/dh to array rowone^ the  first function in brac }
  texttorow(23,sa,mecone,rowone); { mecone terms dF/dh }
  { dS/dH to array rowtwo^ the second function in brac }
  texttorow(13,sb,mectwo,rowtwo); { mectwo terms dS/dH }
  MultForRow(-am); { unrowmul with factor -am  rowtre^ }
  for m:=1 to mectre do    { all terms from rowtre^ }
    begin                  { to array ra^ ma terms }
      ma:=ma+1;            { the next number }
      ra^[ma]:=rowtre^[m]; { for the next term }
    end;
  writeln('+dF/dH*dS/dh-dF/dh*dS/dH',mectre:10,ma:10);
end;
{ to obtain 1/2*[F_1,~S_1]+1/2*[~F_1,~S_1]
  row for  F_1 d F_1/d(L,G,H,l,g,h) in prefol 1 11 12 13 21 22 23 .txt
  row for ~F_1 d~F_1/d(L,G,H,l,g,h) in pregol 1 11 12 13 21 22 23 .txt
  row for ~S_1 d~S_1/d(L,G,H,l,g,h) in pregos 1 11 12 13 21 22 23 .txt }
procedure PoiSecondBra ;
var
  m  : word ; { count for terms }
begin
  maxsum:=numsum;  { global untypvar for giant planet }
  mectmp:=0; { initial nullo terms in temporary array rowtmp^ }
  { for 1/2*[F_1,~S_1] to rowtmp^ }
  writeln('to obtain Poisson brackett for 1/2*[F_1,~S_1]');
  PoissonBrackett(+0.5,'prefol','pregos',mectmp,rowtmp); { factor 1/2 }
  { to add 1/2*[~F_1,~S_1] to rowtmp^ }
  writeln('to obtain Poisson brackett for 1/2*[~F_1,~S_1]');
  PoissonBrackett(+0.5,'pregol','pregos',mectmp,rowtmp); { factor 1/2 }
  writeln('may be similar terms in row for second order function');
  mectre:=0; { rowtmp^ to rowtre^ with similar terms }
  for m:=1 to mectmp do
    NextTerMem(rowtmp^[m],mectre,rowtre); { UnRowMul with similar }
  ForAmpNul(mectre,rowtre); { rowtre may has nullo amplitudes }
  { to correct with power p=1/sqrt(1-e^2) }
  rowcote(mectre,rowtre); { unrowcor procedure }
  { to keep in text file prefol3.txt }
  rowtotext(3,mectre,rowtre,'prefol'); { the second order fucntion }
end;
end.
