{ the values of our parameters are in array parall[..] }
unit unthelpo ; { parameters to different powers }
interface
uses
  untypvar ; { for type trowptr }
{ numsel parameters to different powers to powall }
procedure allparapow ( m  : word ; r  : trowptr ) ;
implementation
{ initial value to array powall[1..numsel][-9..+9] }
procedure powallnullo ; { initial value }
var
  i,j  : shortint ; { counts }
begin
  for i:=1 to numsel do  { all parameters }
    begin
      for j:=-9 to +9  do  { all powers }
        powall[i][j]:=0.0; { default nullo }
      powall[i][0]:=+1.0;      { any parameter in power nullo }
      powall[i][1]:=parall[i]; { any parameter in power  unit }
    end;
end;
{ numsel parameters to different powers to powall }
procedure allparapow ( m  : word ; r  : trowptr ) ;
var                  { number of terms in array }
  k  : byte ;     { count for number of parameters }
  i  : shortint ; { value for positive power }
  j  : shortint ; { value for negative power }
  l  : shortint ; { count for power }
  n  : word ;     { simple count for terms }
  x  : extended ; { current parameter value }
  a  : trowvar ;  { current term to view }
begin
  powallnullo ; { initial value to array powall[..][..] }
  { to obtain
    minimum and maximum power for each parameter }
  k:=0;   { for all numsel parameters }
repeat    { global numsel untypvar }
  k:=k+1; { the next parameter }
  i:=1;   { initial value for maximum (positive) power }
  j:=0;   { initial value for minimum (negative) power }
  { to analyse all terms for this parameter }
  n:=0;        { to start to view }
repeat         { term by term }
  n:=n+1;      { number of the next term }
  a:=r^[n];    { value  of the next term }
  { to analyse current parameter power }
  if  a.mec[k] > i  then  i:=a.mec[k]; { the more larger number positive }
  if  a.mec[k] < j  then  j:=a.mec[k]; { the more less   number negative }
until  n = m ;  { the last term }
  x:=parall[k]; { current parameter value }
  if  ( Abs(x) > 1.0e-12 )  then
    begin
      for l:=-1 downto j do  { for all negative powers of this param }
        powall[k][l]:=powall[k][l+1]/x; { for negative power }
      for l:=2 to i do       { for all positive powers of this parameter }
        powall[k][l]:=powall[k][l-1]*x; { for positive power }
    end;
until  k = numsel ; { the last parameter numsel global untypvar }
end;
end.
