program satgior; { by using mean orbit }
{$APPTYPE CONSOLE}
uses
  SysUtils ,
  untypvar , { procedures GetRowMem FreeRowMem }
  unrowini , { procedures RecNullo RowNullo }
  UnSagCoT , { types constants }
  UnSagReF , { procedures OneSagWith List Name }
  UnEphJpl , { global PlanetName }
  unforprt , { text protocol file fprt }
  ungiamod , { procedure ToObtainModel }
  untheofi , { procedure TheorowtoMem }
  unsagsec ; { for procedure SatGiaSec }

var
  f  : text ;     { text file to read }
  k  : Integer ;  { satellite number in list }
  n  : integer ;  { integer value for step in day }
  m  : integer ;  { number of step to print result }
  a  : Extended ; { start  moment in julian day }
  b  : Extended ; { finish moment in julian day }
  c  : extended ; { previous finish moment }
  x  : extended ; { number of years to integrate may be }
  d  : Extended ; { step in day to integrate }
  p  : extended ; { step in day to print result }
  e  : tsagelm ;  { set of elements for selected object }
  s  : shortstring ; { name of file to print result }

begin
  // Insert user code here

  GetRowMem ;     { from UnTypVar }
  RecNullo ;      { from unrowini nullo to rowvar }
  RowNullo ;      { from unrowini nullo to arrays }

  { before to call planets ephemeris procedures }

  a:=jd2000; { julian day to start  Unsagcot }
  c:=a+200.0*julianc; { julian day to finish }

  assign(f,'satgior.ina'); { text file with simple information }
  reset(f);      { to read to open }
  readln(f,k);   { satellite number in list outsat.txt }
  readln(f,s);   { name of file to print result }
  readln(f,n);   { integer value for step in day to integrate }
  readln(f,m);   { integer value for step in day to print result }
  d:=n; { step in day to integrate }
  p:=m; { step in day to print result }
  c:=c-2.0*d; { two steps earlier then end of file with ephemeris }
  if  not EOF(f)           {  may be the number }
    then  readln(f,x)      { of years to integrate }
    else  x:=(c-a)/365.25; { the full interval }
  close(f); { that is all about this text file }

  b:=a+365.25*x; { finish moment in interval }
  if  b > c      { may be too large }
    then  b:=c;  { to our interval in day }

  ToOpenPrt(s);  { unforprt }
  if  nprt = 131 { there is file with this name }
    then  Exit ; { to finish program }

                       { to find by number in list }
  OneSagWithList(k,e); { UnSagReF in file outsat.txt }

  with  e  do     { information to screen }
    begin
      writeln ;
      writeln(mig:20,'  number of the main planet');
      writeln(PlanetName[mig]:20,'  the main planet'); { unephjpl }
      writeln(snm:20,'  may be the number');
      writeln(stn:20,'  may be the name');
      writeln(epo:20:5,'  epoch of the elements');
      writeln(ela:20:9,'  semimajor axis in AU  ');
      writeln(ele:20:9,'  eccentricity');
      writeln(eli:20:7,'  angle of inclination in degree');
      writeln(eln:20:7,'  the ascending node in degree');
      writeln(elp:20:7,'  the argument of pericentre in degree');
      writeln(elm:20:7,'  mean anomaly in degree');
      writeln ;
      writeln(fprt,PlanetName[mig]:20,'  the main planet'); { unephjpl }
      writeln(fprt,snm,'  may be the number');
      writeln(fprt,stn,'  may be the name');
      writeln(fprt,epo:20:5,'  epoch of the elements');
      writeln(fprt,ela:20:9,'  semimajor axis in AU  ');
      writeln(fprt,ele:20:9,'  eccentricity');
      writeln(fprt,eli:20:7,'  angle of inclination in degree');
      writeln(fprt,eln:20:7,'  the ascending node in degree');
      writeln(fprt,elp:20:7,'  the argument of pericentre in degree');
      writeln(fprt,elm:20:7,'  mean anomaly in degree');
    end;
                        { procedure from ungiamod }
  ToObtainModel(e.mig); { gravitational constants for the main planet }

  TheorowtoMem ; { untheofi to rowone^ rowtwo^ rowtre^ ... }

  SatGiaSec(d,p,a,b,e); { unsagsec to integrate }

  close(fprt); { unforprt protocol text file }

  FreeRowMem ;    { from UnTypVar }

end.
