unit unecanom ; { for the r=a*(1-e*cos(E)) in powers }
interface             { with global numpol from untypvar }
procedure powerange ; { for the r=a*(1-e*cos(E)) in powers }
implementation
uses
  untypvar , { types gloabl variables }
  unrowlow , { procedure LowerRow onetotre }
  unrowmul , { procedure MultForRow }
  unwrtext ; { procedure rowtotext to keep results }
{ r=a-a*e*Cos(E)  two terms }
procedure onerange ; { mecone=2 two terms to array rowone^ }
begin
  mecone:=2; { two terms global UnTypVar }
  { to prepare arrays }
  rowone^[1]:=recnul; { nullo initial but cosinus }
  rowone^[2]:=recnul; { nullo initial but cosinus }
  { to fill arrays }
  rowone^[1].amp[1]:=+1.0; { amplitude }
  rowone^[1].mec[9]:=+1;   { power for a^1 }
  { the second term -a*e*cos(E) }
  rowone^[2].amp[1]:=-1.0; { amplitude }
  rowone^[2].mec[2]:=+1;   { power for e^1 }
  rowone^[2].mec[9]:=+1;   { power for a^1 }
  rowone^[2].mar[2]:=+1;   { cos(E) cosinus default }
end;
{ to use as usual arrays rowone^ rowtwo^ rowtre^ }
procedure powerange ; { for the r=a*(1-e*cos(E)) in powers }
var                   { with global numpol from untypvar }
  n  : byte ; { simple count for power }
begin
  onerange ; { mecone=2 two terms in array rowone^ }
  onetotre ; { array rowtre^ is equal array rowone^ UnRowLow }
  rowtotext(1,mectre,rowtre,'range0'); { unwrtext result }
  for n:=2 to numpol do  { with global numpol from untypvar }
    begin          { power by power for range }
      LowerRow(2); { mectre terms from rowtre^ to rowtwo^ }
      mectre:=0;   { initial nullo number of terms in rowtre^ }
      MultForRow(1.0); { UnRowMul rowone^ * rowtwo^ = rowtre^ }
      rowtotext(n,mectre,rowtre,'range0')  { unwrtext result }
    end;
end;
end.
