unit unfranom ; { for the (1+e'*cos(v') in powers }
interface       { but for the giant planet mec[5..8] mar[5..8] }
procedure powerunge ; { for the (1+e'*cos(v') in powers }
implementation        { with global numpol from untypvar }
uses
  untypvar , { types global variables }
  unrowlow , { procedure LowerRow onetotre }
  unrowmul , { procedure MultForRow }
  unwrtext ; { procedure rowtotext to keep results }
{ (1+e'*cos(v')  two terms }
procedure onerunge ; { mecone=2 two terms to array rowone^ }
begin
  mecone:=2; { two terms global UnTypVar }
  { to prepare arrays }
  rowone^[1]:=recnul; { nullo initial but cosinus }
  rowone^[2]:=recnul; { nullo initial but cosinus }
  { to fill arrays }
  rowone^[1].amp[1]:=+1.0; { amplitude }
  { the second term +e'*cos(v') }
  rowone^[2].amp[1]:=+1.0; { amplitude }
  rowone^[2].mec[6]:=+1;   { power for e'^1 }
  rowone^[2].mar[5]:=+1;   { cos(v') cosinus default }
end;
{ to use as usual arrays rowone^ rowtwo^ rowtre^ }
procedure powerunge ; { for the (1+e'*cos(v')) in powers }
var                   { with global numpol from untypvar }
  n  : byte ; { simple count for power }
begin
  maxsum:=numsum; { for the giant planet variables untypvar }
  onerunge ; { mecone=2 two terms in array rowone^ }
  onetotre ; { array rowtre^ is equal array rowone^ UnRowLow }
  rowtotext(1,mectre,rowtre,'runge0'); { unwrtext result }
  for n:=2 to (numpol+1) do { with global numpol from untypvar }
    begin          { power by power for range }
      LowerRow(2); { mectre terms from rowtre^ to rowtwo^ }
      mectre:=0;   { initial nullo number of terms in rowtre^ }
      MultForRow(1.0); { UnRowMul rowone^ * rowtwo^ = rowtre^ }
      rowtotext(n,mectre,rowtre,'runge0')  { unwrtext result }
    end;
end;
end.
